// P37Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "P37.h"
#include "P37Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CP37Dlg dialog

CP37Dlg::CP37Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CP37Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CP37Dlg)
	m_intN = 0;
	m_intH1 = 0;
	m_intH2 = 0;
	m_strJmeno1 = _T("");
	m_strJmeno2 = _T("");
	m_intPauze = 500;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CP37Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CP37Dlg)
	DDX_Text(pDX, IDC_N, m_intN);
	DDV_MinMaxInt(pDX, m_intN, 2, 10);
	DDX_Text(pDX, IDC_H1, m_intH1);
	DDV_MinMaxInt(pDX, m_intH1, 0, 1);
	DDX_Text(pDX, IDC_H2, m_intH2);
	DDV_MinMaxInt(pDX, m_intH2, 0, 1);
	DDX_Text(pDX, IDC_JMENO1, m_strJmeno1);
	DDX_Text(pDX, IDC_JMENO2, m_strJmeno2);
	DDX_Text(pDX, IDC_N2, m_intPauze);
	DDV_MinMaxInt(pDX, m_intPauze, 0, 10000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CP37Dlg, CDialog)
	//{{AFX_MSG_MAP(CP37Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CP37Dlg message handlers

BOOL CP37Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CP37Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CP37Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CP37Dlg::OnOk() 
{
	UpdateData(TRUE);
	if (m_strJmeno1.Find(' ')!=-1) {
		AfxMessageBox("Ve jmenu nebohou byt mezery!");
		GetDlgItem(IDC_JMENO1)->SetFocus();
		return;
	}
	if (m_strJmeno2.Find(' ')!=-1) {
		AfxMessageBox("Ve jmenu nebohou byt mezery!");
		GetDlgItem(IDC_JMENO2)->SetFocus();
		return;
	}

	if (m_strJmeno1=="") {
		AfxMessageBox("Musite zadat jmeno!");
		GetDlgItem(IDC_JMENO1)->SetFocus();
		return;
	}
	if (m_strJmeno2=="") {
		AfxMessageBox("Musite zadat jmeno!");
		GetDlgItem(IDC_JMENO1)->SetFocus();
		return;
	}
	
	CDialog::OnOK();
}
