// Player.cpp : implementation file
//

#include "stdafx.h"
#include "P37.h"
#include "Player.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Player

Player::Player() : m_intScore(0)
{
}

Player::~Player()
{
}


unsigned long HumanPlayer::GetNextMove(int (&sloupce)[11][10],int (&radky)[11][10],CGConsole *c,int N)
{
	bool done=false;

	int x,y;
	bool je_sloupec;

	while (!done) {
		if (::GetAsyncKeyState(VK_LBUTTON)) {
			CPoint pt;
			::GetCursorPos(&pt);
			c->ScreenToClient(&pt);

			for (int i=0;i<11;i++)
				for (int j=0;j<10;j++)
					if ((pt.x> 2+i*40) &&
						(pt.x< 8+i*40) &&
						(pt.y> 5+j*40) &&
						(pt.y<45+j*40)) {
						je_sloupec=true;
						x=i;
						y=j;

						done=true;
					}

			for (i=0;i<11;i++)
				for (int j=0;j<10;j++)
					if ((pt.x> 5+j*40) &&
						(pt.x<45+j*40) &&
						(pt.y> 2+i*40) &&
						(pt.y< 8+i*40)) {
						je_sloupec=false;
						x=i;
						y=j;

						done=true;
					}

//			CString str;
//			str.Format("%d %d",pt.x,pt.y);
//			MessageBox(NULL,str,"Hi",MB_OK);
			while(::GetAsyncKeyState(VK_LBUTTON)) {}
		}
		else {
			if (c->je_sloupec) {
				if (::GetAsyncKeyState(VK_LEFT)) {
					if (c->m_intKx>0) c->m_intKx--;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_LEFT)) {}
				}
				if (::GetAsyncKeyState(VK_RIGHT)) {
					if (c->m_intKx<N) c->m_intKx++;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_RIGHT)) {}
				}

				if (::GetAsyncKeyState(VK_UP)) {
					if (c->m_intKy>0) c->m_intKy--;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_UP)) {}
				}
				if (::GetAsyncKeyState(VK_DOWN)) {
					if (c->m_intKy<N-1) c->m_intKy++;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_DOWN)) {}
				}
			}
			else {
				if (::GetAsyncKeyState(VK_LEFT)) {
					if (c->m_intKy>0) c->m_intKy--;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_LEFT)) {}
				}
				if (::GetAsyncKeyState(VK_RIGHT)) {
					if (c->m_intKy<N-1) c->m_intKy++;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_RIGHT)) {}
				}

				if (::GetAsyncKeyState(VK_UP)) {
					if (c->m_intKx>0) c->m_intKx--;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_UP)) {}
				}
				if (::GetAsyncKeyState(VK_DOWN)) {
					if (c->m_intKx<N) c->m_intKx++;
					c->Invalidate();

					while(::GetAsyncKeyState(VK_DOWN)) {}
				}
			}

			if (::GetAsyncKeyState(VK_CONTROL)) {	//53=VK_S
				c->je_sloupec=!c->je_sloupec;
				int foo=c->m_intKx;
				c->m_intKx=c->m_intKy;
				c->m_intKy=foo;
				if (c->m_intKx>=N) c->m_intKx=N-1;
				if (c->m_intKy>=N) c->m_intKy=N-1;
				c->Invalidate();
				while(::GetAsyncKeyState(VK_CONTROL)) {}
			}

			if (::GetAsyncKeyState(VK_SPACE)) {
				je_sloupec=c->je_sloupec;
				x=c->m_intKx;
				y=c->m_intKy;
				done=true;
				while(::GetAsyncKeyState(VK_SPACE)) {}
			}

			if (::GetAsyncKeyState(VK_SHIFT)) {
				while(::GetAsyncKeyState(VK_SHIFT)) {}
				return ComputerPlayer().GetNextMove(sloupce,radky,c,N);
			}

		}
	}

//	CString str;
//	str.Format("%d %d",x,y);
//	MessageBox(NULL,str,"Hi",MB_OK);

	unsigned long ret;
	if (je_sloupec)
		ret=1<<31;
	else
		ret=0;
	ret|=(x<<8);
	ret|=y;
	return ret;
}

unsigned long ComputerPlayer::GetNextMove(int (&sloupce)[11][10],int (&radky)[11][10],CGConsole *c,int N)
{
	//ohodnotit kazdou pozici
	//kazda carka zasahuje do dvou ctvercu - zjistit jeji postaveni
	//v kazdem ctverci a secist

	//pokud jsou ve ctverci 3 dalsi - bodu 6
	//pokud jsou ve ctverci 2 dalsi - bodu -5 (priste prohrahu)
	//pokud je ve ctverci 1 dalsi - bodu 2
	//pokud je ve ctverci 0 dalsi - bodu 1

	//najit pote nejvetsi ohodnoceni
	//pokud je jich je vic, vybrat nahodne
	int best=-100;
	int bestx,besty;
	bool je_sloupec;

	for (int i=0;i<N+1;i++)
		for (int j=0;j<N;j++) {
			if (!sloupce[i][j]) {
				int hodnota=Ohodnot_sloupec(sloupce,radky,i,j,N);

				if (hodnota>best) {
					best=hodnota;
					bestx=i;
					besty=j;
					je_sloupec=true;
				}
				else if (hodnota==best)
					if (rand()%10>4) {
						best=hodnota;
						bestx=i;
						besty=j;
						je_sloupec=true;
					}
			}
			if (!radky[i][j]) {
				int hodnota=Ohodnot_radek(sloupce,radky,i,j,N);

				if (hodnota>best) {
					best=hodnota;
					bestx=i;
					besty=j;
					je_sloupec=false;
				}
				else if (hodnota==best)
					if (rand()%10>4) {
						best=hodnota;
						bestx=i;
						besty=j;
						je_sloupec=false;
					}
			}
		}

	unsigned long ret;
	if (je_sloupec)
		ret=1<<31;
	else
		ret=0;
	ret|=(bestx<<8);
	ret|=besty;
	return ret;
}

int ComputerPlayer::Ohodnot_radek(int (&sloupce)[11][10],int (&radky)[11][10],int i,int j,int N) {
	int hod=0;

	if (i<N)
		switch(abs(radky[i+1][j]) + abs(sloupce[j][i]) + abs(sloupce[j+1][i])) {
			case 3:
				hod+=6;
				break;
			case 2:
				hod+=-5;
				break;
			case 1:
				hod+=2;
				break;
			case 0:
				hod+=1;
				break;
			default:
				break;
		}

	if (i>0)
		switch(abs(radky[i-1][j]) + abs(sloupce[j][i-1]) + abs(sloupce[j+1][i-1])) {
			case 3:
				hod+=6;
				break;
			case 2:
				hod+=-5;
				break;
			case 1:
				hod+=2;
				break;
			case 0:
				hod+=1;
				break;
			default:
				break;
		}

	return hod;
}

int ComputerPlayer::Ohodnot_sloupec(int (&sloupce)[11][10],int (&radky)[11][10],int i,int j,int N) {
	int hod=0;

	if (i<N)
		switch(abs(sloupce[i+1][j]) + abs(radky[j][i]) + abs(radky[j+1][i])) {
			case 3:
				hod+=6;
				break;
			case 2:
				hod+=-5;
				break;
			case 1:
				hod+=2;
				break;
			case 0:
				hod+=1;
				break;
			default:
				break;
		}

	if (i>0)
		switch(abs(sloupce[i-1][j]) + abs(radky[j][i-1]) + abs(radky[j+1][i-1])) {
			case 3:
				hod+=5;
				break;
			case 2:
				hod+=-4;
				break;
			case 1:
				hod+=2;
				break;
			case 0:
				hod+=1;
				break;
			default:
				break;
		}

	return hod;

}
