#if !defined(AFX_PLAYER_H__948931E9_5735_11D5_AF01_0080AD889B20__INCLUDED_)
#define AFX_PLAYER_H__948931E9_5735_11D5_AF01_0080AD889B20__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Player.h : header file
//

#include "GConsole.h"


/////////////////////////////////////////////////////////////////////////////
// Player command target

class Player
{
public:
	Player();           // protected constructor used by dynamic creation
	virtual ~Player();

	virtual unsigned long GetNextMove(int (&sloupce)[11][10],int (&radky)[11][10],CGConsole *c,int N)=0;

	int m_intScore;
	CString m_strName;
};

/////////////////////////////////////////////////////////////////////////////

class HumanPlayer : public Player
{
public:
	virtual unsigned long GetNextMove(int (&sloupce)[11][10],int (&radky)[11][10],CGConsole *c,int N);
};

/////////////////////////////////////////////////////////////////////////////

class ComputerPlayer : public Player
{
public:
	virtual unsigned long GetNextMove(int (&sloupce)[11][10],int (&radky)[11][10],CGConsole *c,int N);
private:
	int Ohodnot_radek(int (&sloupce)[11][10],int (&radky)[11][10],int i,int j,int N);
	int Ohodnot_sloupec(int (&sloupce)[11][10],int (&radky)[11][10],int i,int j,int N);
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLAYER_H__948931E9_5735_11D5_AF01_0080AD889B20__INCLUDED_)
